searchNodes=[{"doc":"Elixir wrapper for the GoTrue authentication service.","ref":"GoTrue.html","title":"GoTrue","type":"module"},{"doc":"","ref":"GoTrue.html#client/0","title":"GoTrue.client/0","type":"function"},{"doc":"","ref":"GoTrue.html#client/2","title":"GoTrue.client/2","type":"function"},{"doc":"Get user info using a valid JWT","ref":"GoTrue.html#get_user/1","title":"GoTrue.get_user/1","type":"function"},{"doc":"","ref":"GoTrue.html#get_user/2","title":"GoTrue.get_user/2","type":"function"},{"doc":"Invite a new user to join","ref":"GoTrue.html#invite/1","title":"GoTrue.invite/1","type":"function"},{"doc":"","ref":"GoTrue.html#invite/2","title":"GoTrue.invite/2","type":"function"},{"doc":"Send a password recovery email","ref":"GoTrue.html#recover/1","title":"GoTrue.recover/1","type":"function"},{"doc":"","ref":"GoTrue.html#recover/2","title":"GoTrue.recover/2","type":"function"},{"doc":"Refresh access token using a valid refresh token","ref":"GoTrue.html#refresh_access_token/1","title":"GoTrue.refresh_access_token/1","type":"function"},{"doc":"","ref":"GoTrue.html#refresh_access_token/2","title":"GoTrue.refresh_access_token/2","type":"function"},{"doc":"Send a magic link (passwordless login)","ref":"GoTrue.html#send_magic_link/1","title":"GoTrue.send_magic_link/1","type":"function"},{"doc":"","ref":"GoTrue.html#send_magic_link/2","title":"GoTrue.send_magic_link/2","type":"function"},{"doc":"Get environment settings for the server","ref":"GoTrue.html#settings/0","title":"GoTrue.settings/0","type":"function"},{"doc":"","ref":"GoTrue.html#settings/1","title":"GoTrue.settings/1","type":"function"},{"doc":"Sign in with email and password","ref":"GoTrue.html#sign_in/1","title":"GoTrue.sign_in/1","type":"function"},{"doc":"","ref":"GoTrue.html#sign_in/2","title":"GoTrue.sign_in/2","type":"function"},{"doc":"Sign out user using a valid JWT","ref":"GoTrue.html#sign_out/1","title":"GoTrue.sign_out/1","type":"function"},{"doc":"","ref":"GoTrue.html#sign_out/2","title":"GoTrue.sign_out/2","type":"function"},{"doc":"Sign up a new user with email and password","ref":"GoTrue.html#sign_up/1","title":"GoTrue.sign_up/1","type":"function"},{"doc":"","ref":"GoTrue.html#sign_up/2","title":"GoTrue.sign_up/2","type":"function"},{"doc":"","ref":"GoTrue.html#update_header/2","title":"GoTrue.update_header/2","type":"function"},{"doc":"Update user info using a valid JWT","ref":"GoTrue.html#update_user/2","title":"GoTrue.update_user/2","type":"function"},{"doc":"","ref":"GoTrue.html#update_user/3","title":"GoTrue.update_user/3","type":"function"},{"doc":"Generate a URL for authorizing with an OAUTH2 provider","ref":"GoTrue.html#url_for_provider/1","title":"GoTrue.url_for_provider/1","type":"function"},{"doc":"","ref":"GoTrue.html#url_for_provider/2","title":"GoTrue.url_for_provider/2","type":"function"},{"doc":"GoTrueAn Elixir client for GoTrue.GoTrue is an open source authentication service that supports many methods of authentication:Classic email+password loginsPasswordless logins with magic linksOAUTH2 - Google, GitHub, BitBucket, GitLab, etc..SAML/SSODocumentationWhy?GoTrue is a way of doing authentication by delagating the work to a separate service. It has a very slim HTTP API, so less code to maintain. It's also a polyglot auth solution.It was developed by Netlify, though this version is being developed against the supabase forkFor many apps, phx_gen_auth is a great solution, but it requires a bit more work to setup and adjust. It does mean inheriting a bunch of code. For a small team, or for quick experimentation, offloading a task like auth removes a big friction and reduces time to market.It also makes it possibile to create an Elixir supabase client down the road.","ref":"readme.html","title":"GoTrue","type":"extras"},{"doc":"Add gotrue to your list of dependencies in mix.exs:def deps do [ {:gotrue, &quot;~&gt; 0.1.0&quot;} ] endOptionalIn your config/dev.exs &amp; config/prod.exs, configure settings:config :gotrue, # URL to your GoTrue instance base_url: &quot;http://0.0.0.0:9999&quot;, # The project&#39;s API key api_key: &quot;your-super-secret-operator-token&quot; Usage","ref":"readme.html#installation","title":"GoTrue - Installation","type":"extras"},{"doc":"Several options exist to create an account:Password basedPass credentials to GoTrue.sign_up/1, a new account will be created and a JWT token is returned.GoTrue.client(&quot;https://ttlzokxvatvexhtzrpsm.supabase.co/auth/v1&quot;, &quot;my-supabase-project-api-key&quot;) |&gt; GoTrue.sign_up(%{email: &quot;user@example.com&quot;, password: &quot;123456&quot;})OAUTH2Oauth is performed on the client by redirecting the user. To get the redirection URL, call GoTrue.url_for_provider/1:GoTrue.url_for_provider(:google) GoTrue.url_for_provider(:github) GoTrue.url_for_provider(:gitlab) GoTrue.url_for_provider(:bitbucket) GoTrue.url_for_provider(:facebook)Magic LinkUsers can login without password, by requesting a magic link:GoTrue.client(&quot;https://ttlzokxvatvexhtzrpsm.supabase.co/auth/v1&quot;, &quot;my-supabase-project-api-key&quot;) |&gt; GoTrue.send_magic_link(&quot;user@example.com&quot;)That sends them an email with a link to login. The link will contain the access_token &amp; refresh_token.","ref":"readme.html#creating-a-user-account","title":"GoTrue - Creating a user account","type":"extras"},{"doc":"If you're using password logins, sign in a user by passing the email &amp; password to GoTrue.sign_in/1, it returns a JWTGoTrue.client(&quot;https://ttlzokxvatvexhtzrpsm.supabase.co/auth/v1&quot;, &quot;my-supabase-project-api-key&quot;) |&gt; GoTrue.sign_in(%{email: &quot;user@example.com&quot;, password: &quot;12345&quot;})","ref":"readme.html#sign-in","title":"GoTrue - Sign in","type":"extras"},{"doc":"Each JWT expires based on your GoTrue server's settings. To refresh it, pass the refresh_token to GoTrue.refresh_access_token/1# first get an access token, there are many ways: # via sign up %{access_token: jwt, refresh_token: refresh_token} = GoTrue.sign_up(...) # or via login %{access_token: jwt, refresh_token: refresh_token} = GoTrue.sign_in(...) # or via a redirection from an oauth provider def controller_action(conn, %{access_token: jwt, refresh_token: refresh_token}) do # put in session end # refresh it before it expires %{access_token: new_jwt} = GoTrue.refresh_access_token(refresh_token)","ref":"readme.html#refreshing-jwt","title":"GoTrue - Refreshing JWT","type":"extras"},{"doc":"To revoke a JWT, call GoTrue.sign_out/1GoTrue.sign_out(jwt)","ref":"readme.html#sign-out","title":"GoTrue - Sign out","type":"extras"},{"doc":"The user's info can be accessed by calling GoTrue.get_user/1 with their current JWT:GoTrue.get_user(jwt)","ref":"readme.html#getting-user-info","title":"GoTrue - Getting user info","type":"extras"},{"doc":"Using a JWT, the user's data can be updated by calling GoTrue.update_user/2GoTrue.update_user(jwt, %{data: %{favorite_language: &quot;elixir&quot;}})","ref":"readme.html#updating-user-info","title":"GoTrue - Updating user info","type":"extras"},{"doc":"Users can be invited by passing their email address to GoTrue.invite/1, this sends them an email with a completion link.GoTrue.invite(%{email: &quot;user@example.com&quot;})","ref":"readme.html#invitations","title":"GoTrue - Invitations","type":"extras"},{"doc":"To view the server's auth settings, call GoTrue.settings()LicenseMIT","ref":"readme.html#settings","title":"GoTrue - Settings","type":"extras"}]